library(viridis)
library(lattice)
################
# All variables
################
configFile_path <- "/esarchive/scratch/jmateu/run_sensitivity/config_file.yml"
n_z   = 47
n_t   = 73
n_var = 8
var_names <-c("POC","GOC","PHY","PHY2","ZOO","ZOO2","NCHL","DCHL")#     <- config$var_names
################
# exp variables
################
configFile_path <- "/esarchive/scratch/jmateu/run_sensitivity2/config_file.yml"
n_z   = 46
n_t   = 73
n_var = 2
var_names <-c("EXPPOC","EXPGOC")#     <- config$var_names
################
# supervariables
################
configFile_path <- "/esarchive/scratch/jmateu/run_sensitivity3/config_file.yml"
n_z   = 47
n_t   = 73
n_var = 4
var_names <-c("sPOC","lPOC","totalPOC","totalCHL") #  <- config$var_names



################
# Load data to plot
################
config         <- yaml::yaml.load_file(configFile_path)
nparams        <- config$nparams
image_folder   <- config$image_folder
sim_data       <- config$sim_data
param_names    <- config$param_names
repo           <- config$repo

source(paste0(repo,"UQtools4es.R"))

forcing_file <- "/gpfs/scratch/bsc32/bsc32340/a5z7/EXP00/cropped/a2mc_1d_20150101_20151231_OfflineForcing_grid_T.nc"
forcing     <- RNetCDF::open.nc(forcing_file)
#RNetCDF::print.nc(forcing)
mldkz      <- RNetCDF::var.get.nc(forcing, 'mldkz5') #Latitut
deptht      <- RNetCDF::var.get.nc(forcing, 'olevel') #Latitut
mldkz <- mldkz[2,2,seq(1,365,5)]

Sobol_global3 <- readRDS(paste0(sim_data,"Sobol_global3.RDS"))
################
# plot first index
################
data_for_plot =Sobol_global3[[1]]

for (param in 1:nparams) { # loop over the model parameters 
  for (var in 1:n_var) { # loop over the variables to plot the correspondent field 
    pdf(file = paste0(image_folder,"S1_",var_names[var],"_", param_names[param] ,".pdf"), width = 5, height = 3)
    print(plot_field(var,param,data_for_plot,n_z,n_t,deptht,mldkz))
    dev.off()
  
  }
}

################
# plot total index
################
data_for_plot =Sobol_global3[[2]]

for (param in 1:nparams) { # loop over the model parameters 
  for (var in 1:n_var) { # loop over the variables to plot the correspondent field 
    pdf(file = paste0(image_folder,"ST_",var_names[var],"_", param_names[param] ,".pdf"), width = 5, height = 3)
    print(plot_field(var,param,data_for_plot,n_z,n_t,deptht,mldkz))
    dev.off()
  }
}
