# Script to test sobol implementation by comparison with "Comparison of two sets of Monte Carlo estimators of Sobol’ indices" paper

# 

####  The Ishigami function #### 
ishigami_function <- function(newdata) {
  res_vector <-
    sin(newdata[,1]) +
    7*sin(newdata[,2])*sin(newdata[,2]) +
    0.1*newdata[,3]^4*sin(newdata[,1])

  res_vector2 <-
    100 +
    sin(newdata[,1]) +
    7*sin(newdata[,2])*sin(newdata[,2]) +
    0.1*newdata[,3]^4*sin(newdata[,1])
  
  
  res_vector3 <-
    1000 +
    sin(newdata[,1]) +
    7*sin(newdata[,2])*sin(newdata[,2]) +
    0.1*newdata[,3]^4*sin(newdata[,1])
  res <- cbind(res_vector,  res_vector2 ,res_vector3)
  
  dimnames(res)[[2]][ncol(res)] <- ""
  
  return(res)
}


sobol.fun_matrix <- function(X){
  res_vector <- sobol.fun(X)
  res_vector <- cbind(res_vector,res_vector,res_vector)
  dimnames(res_vector)[[2]][3] <- ""
  return(res_vector)
}


x_matrix <- sobolmartinez(model = ishigami_function, X1, X2)



####  Generate Random Sobol sequence of model parameters to analyze sensitivity ####
lds <- runif.sobol(n = nsims, dimension = 4, scrambling = 3)
new_value <- lds
for (j in 1:4){
  new_value[,j] = -pi + lds[,j]*2*pi
}
new_value <- as.data.frame(new_value)


####  Randomly split data #### 
sobol_size <- floor(0.5 * nrow(new_value))
random_index <- sample(seq_len(nrow(new_value)), size = sobol_size)
X1 <- new_value[random_index,]
X2 <- new_value[-random_index,]

names(X1) <- paste0('X', 1:ncol(X1))
names(X2) <- paste0('X', 1:ncol(X2))

####  Compute sobol #### 
sobol_indexs <- sobolmartinez(model = sobol.fun_matrix,
                              X1 = X1,
                              X2 = X2)


n <- 1000
X1 <- data.frame(matrix(runif(8 * n), nrow = n))
X2 <- data.frame(matrix(runif(8 * n), nrow = n))


